package com.loafle.overflow.module.member.service;

import com.loafle.overflow.module.member.dao.MemberDAO;
import com.loafle.overflow.module.member.model.Member;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;

/**
 * Created by geek on 17. 6. 28.
 */
@Service
public class MemberService {

    @Autowired
    private MemberDAO memberDAO;

    public Member signin(Member member) throws Exception {
        Member m = this.memberDAO.findByEmail(member);

        if ( null == m ) {
            return m;
        }

        if ( m.getStatus().getId() == 1 ) {
            throw new Exception("Email Auth Confirm Check");
        }

        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        Boolean match = passwordEncoder.matches(member.getPw(), m.getPw());
        if(!match) return null;

        return m;
    }

    public Member signup(Member member) {

        BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
        member.setPw(passwordEncoder.encode(member.getPw()));
        return this.memberDAO.save(member);
    }

    public void signout(Member member) {
        // Todo websocket session remove
    }

    public Member modify(Member member) {

        return this.memberDAO.save(member);
    }

    public Member read(long memberId) {
        return this.memberDAO.findOne(memberId);
    }

    public void withdrawal(Member member) {
        // Todo DB delete?
    }

    public void emailConfirm(Member member) {

    }
}
