package com.loafle.overflow.module.sensor.service;

import com.loafle.overflow.module.meta.model.MetaSensorStatus;
import com.loafle.overflow.module.sensor.dao.SensorDAO;
import com.loafle.overflow.module.sensor.model.Sensor;
import com.loafle.overflow.module.target.model.Target;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
@Service
public class SensorService  {

    @Autowired
    SensorDAO sensorDAO;

    public Sensor regist(Sensor sensor) {
        return this.sensorDAO.save(sensor);
    }

    public List<Sensor> readAllByTarget(Target target) {
        return this.sensorDAO.findAllByTarget(target);
    }

    public Sensor read(String id) {
        return this.sensorDAO.findOne(Long.valueOf(id));
    }

    public void remove(Sensor sensor) {
        this.sensorDAO.delete(sensor);
    }

    public Sensor start(Sensor sensor) {
        MetaSensorStatus status = new MetaSensorStatus((short)1);
        sensor.setStatus(status);
        return this.sensorDAO.save(sensor);
    }

    public Sensor stop(Sensor sensor) {
        MetaSensorStatus status = new MetaSensorStatus((short)2);
        sensor.setStatus(status);
        return this.sensorDAO.save(sensor);
    }
}
